=== debian/changelog ===
obs-studio (22.0.2-0obsproject1~bionic+pearl7.6) rolltide; urgency=medium

  * re versioning

 -- Scott Vandergrift <scottvandergrift@gmail.com>  Sat, 08 Sep 2018 13:50:50 -0500

obs-studio (22.0.2-0obsproject1~bionic+pearl7) rolltide; urgency=medium

  * fixed duplicate file in other package error

 -- Scott Vandergrift <scottvandergrift@gmail.com>  Sat, 08 Sep 2018 13:38:02 -0500

obs-studio (22.0.2-0obsproject1~bionic) bionic; urgency=low

  OBS Studio 22.0.2

  22.0.2 Hotfix

  * Fixed a bug where the program could sometimes mistakenly use a different server than the one selected
  * Fixed a bug where copying and pasting sources would not paste the transform
  * Fixed a bug where using a custom server with authentication would no longer work
  * Fixed a bug on macOS where the browser source would not update properly
  * Fixed a bug on macOS where leaving the browser source interaction window could cause a crash
  * Fixed a bug on macOS where the lock icons in the source list would disappear under the scrollbar if the scrollbar was visible
  * Fixed a case where the multiview could crash on certain Linux desktop environments
  * Fixed a potential crash on startup that could happen under rare circumstances
  * Fixed a few cases where the "Start Streaming" and/or "Stop Streaming" hotkeys could mysteriously disappear from the hotkeys section of the settings window
  * Fixed a bug where the filters window would show the preview very squished
  * Fixed a bug where the browser source sometimes wouldn't paint properly
  * The "Make projectors always on top" option now also properly applies to windowed projectors as well
  * When using Windows 7, the browser source's hardware acceleration is now disabled by default due to potential incompatibilities with older drivers
  * When using Intel video adapters with the program, the browser source's hardware acceleration is now disabled by default due to incompatibilities with many Intel integrated video adapters
  * Removed the "Beta" warning from the Auto-Configuration tool

  22.0.1 Hotfix

  * Fixed a bug where the browser source wouldn't read local files properly

  22.0 General Changes

  * Major improvements to the browser source:

  - Added hardware acceleration to the browser source on Windows for greatly improved performance, reduced resources, and allowing advanced rendering functionality such as WebGL.  This reduces CPU usage, reduces RAM usage, and even reduces GPU usage.  This option is enabled by default; it can be disabled in the advanced section of settings if needed if there are any unexpected issues.
  - Refactored the entire plugin and pruned approximately 13,000 lines of code (very satisfying for me in particular)
  - Updated to Chromium 68
  - The browser source now has accurate frame synchronization on Windows
  - Fixed all memory leaks of the browser source
  - Added the ability to use web browsers as widgets (which isn't currently exposed much, but will allow a lot more custom functionality later)

  * Added source grouping, allowing the ability to group multiple sources together as a single transformable group:

  - To add a group, you can either select a few sources and then right-click and choose "Group Selected Items", or you can create an empty group in the Add menu
  - You can seamlessly drag and drop items in and out of groups
  - You can ungroup a group without affecting the group in other scenes by right-clicking the group and choosing "Ungroup"
  - Groups show their list of sources as a sub-list within the main scene list, which can be collapsed and hidden if desired
  - Groups can be referenced (shared) between multiple scenes like any other source
  - Groups can have their own effect filters applied to them

  * Added the ability to set a custom background color to items within the source list to color-code them for improved organization:

  - To set the item's background color, right-click the source item within the source list, and go to "Set Color"
  - You can use a preset selection of colors within the menu, you can choose a custom color, or you can reset it to default

  * Added a "Vertical Layout" option to the mixer's right-click context menu to make the mixer display vertically rather than horizontally (#1257)
  * The multiview can now be configured to show up to 24 scenes at once in general settings if desired (#1260)
  * Added an option to audio settings to allow the user to change the audio meter type "Sample Peak" and "True Peak" #1189
  * Added secure streaming (RTMPS) support for services that support it, such as Facebook (#1360)
  * It is now possible to use more than one Intel QSV encoder at once (#1341)
  * It is now possible to use alt-cropping even on sources that are set to a bounding box transform.  This fixes the issue where, for example, alt-cropping would not work after you pressed Ctrl-F on a source.  Note that in that case, the rectangle's size will not change, but the contents will realign to the rectangle.  (01ac60c)
  * Windowed projectors are now saved and loaded on shutdown/startup (#1195)
  * Audio sources within the mixer now always displayed alphabetically (#1242)
  * Significantly reduced GPU usage when the program is idle (I.E. when the program is not streaming or recording) (45b5291)
  * Added a confirmation dialog when the user has not added video sources to any scenes, warning them that they are about to stream a blank screen.  This ensures that new users do not inadvertently stream without at least first adding some sources.  (310c98e)
  * The program will now default to the NVIDIA GPU when on laptops that have both NVIDIA and Intel integrated adapters.  This can still be overridden in the NVIDIA control panel if desired

  22.0 Bug Fixes

  * Fixed a bug where videos recorded with certain formats would report that they were 1000 FPS in their metadata when they actually weren't (1f592d1)

