=== debian/control ===
Source: obs-studio
Section: video
Priority: optional
Maintainer: Scott Vandergrift <scottvandergrift@gmail.com>
Orig-Maintainer: John Bradley <jrb@turrettech.com>
Uploaders: Kevin Henkel <obs.goldace@gmail.com>
Build-Depends: debhelper (>= 9), cdbs, cmake, git, libx11-dev, libgl1-mesa-dev | libgl-dev, libpulse-dev, libxcomposite-dev, libxinerama-dev, libv4l-dev, libudev-dev, libfreetype6-dev, libfontconfig-dev, qtbase5-dev, libqt5x11extras5-dev, libx264-dev, libxcb-xinerama0-dev, libxcb-shm0-dev, libavformat-dev, libswscale-dev, libswresample-dev, libavdevice-dev, libavfilter-dev, libfdk-aac-dev, libjack-jackd2-dev, libcurl4-openssl-dev, libspeexdsp-dev, libvlc-dev, libasound2-dev, libluajit-5.1-dev, python3-dev, swig, libmbedtls-dev
Homepage: http://obsproject.org

Package: obs-studio
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libobs0, libobs0:amd64, obs-plugins, obs-studio
Replaces: libobs0, libobs0:amd64, obs-plugins, obs-studio
Description: OBS Studio for Pearl
